// Random Skinchanger


#include <sourcemod>
#include <sdktools>

#pragma semicolon 1

#define PLUGIN_VERSION "1.1"
#define MAX_FILE_LEN 256
#define MODELS_PER_CLASS 24

// Plugin definitions
public Plugin:myinfo =
{
	name = "Dod Randomclass Modelchanger",
	author = "Andi67",
	version = PLUGIN_VERSION,
	description = "Gives each player a random custom skin.",
	url = "http://www.andi67-blog.de.vu"
};

// Plugin Mode
new bool:g_Use_Custom_Models = true;
new bool:g_PrecacheClean = false;
// Custom Models
new String:g_Models_ALLIEDRIFLE[MODELS_PER_CLASS][MAX_FILE_LEN];
new String:g_Models_Count_ALLIEDRIFLE;
new String:g_Models_ALLIEDASSAULT[MODELS_PER_CLASS][MAX_FILE_LEN];
new String:g_Models_Count_ALLIEDASSAULT;
new String:g_Models_ALLIEDSUPPORT[MODELS_PER_CLASS][MAX_FILE_LEN];
new String:g_Models_Count_ALLIEDSUPPORT;
new String:g_Models_ALLIEDSNIPER[MODELS_PER_CLASS][MAX_FILE_LEN];
new String:g_Models_Count_ALLIEDSNIPER;
new String:g_Models_ALLIEDMG[MODELS_PER_CLASS][MAX_FILE_LEN];
new String:g_Models_Count_ALLIEDMG;
new String:g_Models_ALLIEDROCKET[MODELS_PER_CLASS][MAX_FILE_LEN];
new String:g_Models_Count_ALLIEDROCKET;

new String:g_Models_AXISRIFLE[MODELS_PER_CLASS][MAX_FILE_LEN];
new String:g_Models_Count_AXISRIFLE;
new String:g_Models_AXISASSAULT[MODELS_PER_CLASS][MAX_FILE_LEN];
new String:g_Models_Count_AXISASSAULT;
new String:g_Models_AXISSUPPORT[MODELS_PER_CLASS][MAX_FILE_LEN];
new String:g_Models_Count_AXISSUPPORT;
new String:g_Models_AXISSNIPER[MODELS_PER_CLASS][MAX_FILE_LEN];
new String:g_Models_Count_AXISSNIPER;
new String:g_Models_AXISMG[MODELS_PER_CLASS][MAX_FILE_LEN];
new String:g_Models_Count_AXISMG;
new String:g_Models_AXISROCKET[MODELS_PER_CLASS][MAX_FILE_LEN];
new String:g_Models_Count_AXISROCKET;
// Default Models
static const String:alliesriflemodels[1][] = {"models/player/american_rifleman.mdl"};
static const String:alliesassaultmodels[1][] = {"models/player/american_assault.mdl"};
static const String:alliessupportmodels[1][] = {"models/player/american_support.mdl"};
static const String:alliessnipermodels[1][] = {"models/player/american_sniper.mdl"};
static const String:alliesmgmodels[1][] = {"models/player/american_mg.mdl"};
static const String:alliesrocketmodels[1][] = {"models/player/american_rocket.mdl"};


static const String:axisriflemodels[1][] = {"models/player/german_rifleman.mdl"};
static const String:axisassaultmodels[1][] = {"models/player/german_assault.mdl"};
static const String:axissupportmodels[1][] = {"models/player/german_support.mdl"};
static const String:axissnipermodels[1][] = {"models/player/german_sniper.mdl"};
static const String:axismgmodels[1][] = {"models/player/german_mg.mdl"};
static const String:axisrocketmodels[1][] = {"models/player/german_rocket.mdl"};


public OnPluginStart()
{
	CreateConVar("dod_randomclass_modelchanger_version", PLUGIN_VERSION, "[DOD] Dod Randomclass Modelchanger Version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);

	RegAdminCmd("changemodel", Command_SetCustom, ADMFLAG_SLAY);

	HookEvent("player_spawn", EventPlayerSpawn, EventHookMode_Post);
}

public OnMapStart()
{
	g_Models_Count_ALLIEDRIFLE = 0;
	g_Models_Count_ALLIEDASSAULT = 0;
	g_Models_Count_ALLIEDSUPPORT = 0;
	g_Models_Count_ALLIEDSNIPER = 0;
	g_Models_Count_ALLIEDMG = 0;
	g_Models_Count_ALLIEDROCKET = 0;
	
	g_Models_Count_AXISRIFLE = 0;
	g_Models_Count_AXISASSAULT = 0;
	g_Models_Count_AXISSUPPORT = 0;
	g_Models_Count_AXISSNIPER = 0;
	g_Models_Count_AXISMG = 0;
	g_Models_Count_AXISROCKET = 0;	
	
	g_Models_Count_ALLIEDRIFLE = LoadModels(g_Models_ALLIEDRIFLE, "configs/dod_randomclass_modelchanger/models_alliedrifle.ini");
	g_Models_Count_ALLIEDASSAULT = LoadModels(g_Models_ALLIEDASSAULT,  "configs/dod_randomclass_modelchanger/models_alliedassault.ini");	
	g_Models_Count_ALLIEDSUPPORT = LoadModels(g_Models_ALLIEDSUPPORT,  "configs/dod_randomclass_modelchanger/models_alliedsupport.ini");
	g_Models_Count_ALLIEDSNIPER = LoadModels(g_Models_ALLIEDSNIPER,  "configs/dod_randomclass_modelchanger/models_alliedsniper.ini");
	g_Models_Count_ALLIEDMG = LoadModels(g_Models_ALLIEDMG,  "configs/dod_randomclass_modelchanger/models_alliedmg.ini");
	g_Models_Count_ALLIEDROCKET = LoadModels(g_Models_ALLIEDROCKET,  "configs/dod_randomclass_modelchanger/models_alliedrocket.ini");	
	
	g_Models_Count_AXISRIFLE = LoadModels(g_Models_ALLIEDRIFLE, "configs/dod_randomclass_modelchanger/models_axisrifle.ini");
	g_Models_Count_AXISASSAULT = LoadModels(g_Models_ALLIEDASSAULT,  "configs/dod_randomclass_modelchanger/models_axisassault.ini");	
	g_Models_Count_AXISSUPPORT = LoadModels(g_Models_ALLIEDSUPPORT,  "configs/dod_randomclass_modelchanger/models_axissupport.ini");
	g_Models_Count_AXISSNIPER = LoadModels(g_Models_ALLIEDSNIPER,  "configs/dod_randomclass_modelchanger/models_axissniper.ini");
	g_Models_Count_AXISMG = LoadModels(g_Models_ALLIEDMG,  "configs/dod_randomclass_modelchanger/models_axismg.ini");
	g_Models_Count_AXISROCKET = LoadModels(g_Models_ALLIEDROCKET,  "configs/dod_randomclass_modelchanger/models_axisrocket.ini");		

	if (g_Models_Count_ALLIEDRIFLE == 0) SetFailState("[DOD] dod_randomclass_modelchanger Error: No Custom ALLIEDRifle Models found");
	if (g_Models_Count_ALLIEDASSAULT== 0) SetFailState("[DOD] dod_randomclass_modelchanger Error: No Custom ALLIEDAssault Models found");
	if (g_Models_Count_ALLIEDSUPPORT == 0) SetFailState("[DOD] dod_randomclass_modelchanger Error: No Custom ALLIEDSupport Models found");
	if (g_Models_Count_ALLIEDMG == 0) SetFailState("[DOD] dod_randomclass_modelchanger Error: No Custom ALLIEDMg Models found");
	if (g_Models_Count_ALLIEDSNIPER == 0) SetFailState("[DOD] dod_randomclass_modelchanger Error: No Custom ALLIEDSniper Models found");
	if (g_Models_Count_ALLIEDROCKET == 0) SetFailState("[DOD] dod_randomclass_modelchanger Error: No Custom ALLIEDRocket Models found");
	
	if (g_Models_Count_AXISRIFLE == 0) SetFailState("[DOD] dod_randomclass_modelchanger Error: No Custom AXISRifle Models found");
	if (g_Models_Count_AXISASSAULT== 0) SetFailState("[DOD] dod_randomclass_modelchanger Error: No Custom AXISAssault Models found");
	if (g_Models_Count_AXISSUPPORT == 0) SetFailState("[DOD] dod_randomclass_modelchanger Error: No Custom AXISSupport Models found");
	if (g_Models_Count_AXISMG == 0) SetFailState("[DOD] dod_randomclass_modelchanger Error: No Custom AXISMg Models found");
	if (g_Models_Count_AXISSNIPER == 0) SetFailState("[DOD] dod_randomclass_modelchanger Error: No Custom AXISSniper Models found");
	if (g_Models_Count_AXISROCKET == 0) SetFailState("[DOD] dod_randomclass_modelchanger Error: No Custom AXISRocket Models found");		
	PrintToServer("[DOD] dod_randomclass_modelchanger Applier v%s: %d models precached.", PLUGIN_VERSION, g_Models_Count_ALLIEDRIFLE+g_Models_Count_ALLIEDASSAULT+g_Models_Count_ALLIEDSUPPORT+g_Models_Count_ALLIEDSNIPER+g_Models_Count_ALLIEDMG+g_Models_Count_ALLIEDROCKET+g_Models_Count_AXISRIFLE+g_Models_Count_AXISASSAULT+g_Models_Count_AXISSUPPORT+g_Models_Count_AXISSNIPER+g_Models_Count_AXISMG+g_Models_Count_AXISROCKET);

	// OnMapStart() is also called if plugin loaded in the middle of a round
	// We must wait for an actual map load before enabling the plugin
	if (GetClientCount(false) == 0) g_PrecacheClean = true;
}


stock LoadModels(String:models[][], String:ini_file[])
{
	decl String:buffer[MAX_FILE_LEN];
	decl String:file[MAX_FILE_LEN];
	new models_count;

	BuildPath(Path_SM, file, MAX_FILE_LEN, ini_file);

	//open precache file and add everything to download table
	new Handle:fileh = OpenFile(file, "r");
	while (ReadFileLine(fileh, buffer, MAX_FILE_LEN))
	{
		// Strip leading and trailing whitespace
		TrimString(buffer);

		// Skip non existing files (and Comments)
		if (FileExists(buffer))
		{
			// Tell Clients to download files
			AddFileToDownloadsTable(buffer);
			// Tell Clients to cache model
			if (StrEqual(buffer[strlen(buffer)-4], ".mdl", false) && (models_count<MODELS_PER_CLASS))
			{
				strcopy(models[models_count++], strlen(buffer)+1, buffer);
				PrecacheModel(buffer, true);
			}
		}
	}
	return models_count;
}


public Action:Command_SetCustom(client, args)
{
	if (args < 1)
	{
		ReplyToCommand(client, "[DOD] Usage: dod_randomclass_modelchanger <0/1/list>");
		ReplyToCommand(client, "    dod_randomclass_modelchanger = %d", ((g_Use_Custom_Models) ? 1 : 0));
		if (!g_PrecacheClean)
			ReplyToCommand(client, "    * Waiting for map change");
		return Plugin_Handled;
	}

	// Get the command
	decl String:command[MAX_FILE_LEN];
	GetCmdArg(1, command, MAX_FILE_LEN);

	// Disable Plugin - Used standard models
	if(command[0] == '0')
	{
		g_Use_Custom_Models = false;
		for(new client_index = 1; client_index <= MaxClients; client_index++)
		{
			if(IsClientInGame(client_index))
			{
				PrintToChat(client_index, "[DOD] Your custom model has been removed");
				set_random_default_model(client_index);
			}
		}
	}

	// Enable Plugin - Used custom models
	if(command[0] == '1')
	{
		g_Use_Custom_Models = true;
		if (!g_PrecacheClean)
		{
			ReplyToCommand(client, "[DOD] Changes will take affect after clients download models on map change");
			return Plugin_Handled;
		}
		for(new client_index = 1; client_index <= MaxClients; client_index++)
		{
			if(IsClientInGame(client_index))
			{
				PrintToChat(client_index, "[DOD] You have been given a custom model");
				set_random_custom_model(client_index);
			}
		}
	}

	// List custom models by team
	if(StrEqual(command, "list"))
	{
		// List Rifle Models
		ReplyToCommand(client, "Allies Rifle Models:");
		if(g_Models_Count_ALLIEDRIFLE > 0)
			for(new model = 0; model < g_Models_Count_ALLIEDRIFLE; ++model)
				ReplyToCommand(client, "    %s", g_Models_ALLIEDRIFLE[model]);
		else
			ReplyToCommand(client, "    None found");
			
		// List Assault Models
		ReplyToCommand(client, "Allies Assault Models:");
		if(g_Models_Count_ALLIEDASSAULT > 0)
			for(new model = 0; model < g_Models_Count_ALLIEDASSAULT; ++model)
				ReplyToCommand(client, "    %s", g_Models_ALLIEDASSAULT[model]);
		else
			ReplyToCommand(client, "    None found");
			
		// List Support Models
		ReplyToCommand(client, "Allies Support Models:");
		if(g_Models_Count_ALLIEDSUPPORT > 0)
			for(new model = 0; model < g_Models_Count_ALLIEDSUPPORT; ++model)
				ReplyToCommand(client, "    %s", g_Models_ALLIEDSUPPORT[model]);
		else
			ReplyToCommand(client, "    None found");
			
		// List Sniper Models
		ReplyToCommand(client, "Allies Sniper Models:");
		if(g_Models_Count_ALLIEDSNIPER > 0)
			for(new model = 0; model < g_Models_Count_ALLIEDSNIPER; ++model)
				ReplyToCommand(client, "    %s", g_Models_ALLIEDSNIPER[model]);
		else
			ReplyToCommand(client, "    None found");
			
		// List Mg Models
		ReplyToCommand(client, "Allies Mg Models:");
		if(g_Models_Count_ALLIEDMG> 0)
			for(new model = 0; model < g_Models_Count_ALLIEDMG; ++model)
				ReplyToCommand(client, "    %s", g_Models_ALLIEDMG[model]);
		else
			ReplyToCommand(client, "    None found");
			
		// List Rocket Models
		ReplyToCommand(client, "Allies Rocket Models:");
		if(g_Models_Count_ALLIEDROCKET > 0)
			for(new model = 0; model < g_Models_Count_ALLIEDROCKET; ++model)
				ReplyToCommand(client, "    %s", g_Models_ALLIEDROCKET[model]);
		else
			ReplyToCommand(client, "    None found");
			
			
			
			
		// List Rifle Models
		ReplyToCommand(client, "Axis Rifle Models:");
		if(g_Models_Count_AXISRIFLE > 0)
			for(new model = 0; model < g_Models_Count_AXISRIFLE; ++model)
				ReplyToCommand(client, "    %s", g_Models_AXISRIFLE[model]);
		else
			ReplyToCommand(client, "    None found");
			
		// List Assault Models
		ReplyToCommand(client, "Axis Assault Models:");
		if(g_Models_Count_AXISASSAULT > 0)
			for(new model = 0; model < g_Models_Count_AXISASSAULT; ++model)
				ReplyToCommand(client, "    %s", g_Models_AXISASSAULT[model]);
		else
			ReplyToCommand(client, "    None found");
			
		// List Support Models
		ReplyToCommand(client, "Axis Support Models:");
		if(g_Models_Count_AXISSUPPORT > 0)
			for(new model = 0; model < g_Models_Count_AXISSUPPORT; ++model)
				ReplyToCommand(client, "    %s", g_Models_AXISSUPPORT[model]);
		else
			ReplyToCommand(client, "    None found");
			
		// List Sniper Models
		ReplyToCommand(client, "Axis Sniper Models:");
		if(g_Models_Count_AXISSNIPER > 0)
			for(new model = 0; model < g_Models_Count_AXISSNIPER; ++model)
				ReplyToCommand(client, "    %s", g_Models_AXISSNIPER[model]);
		else
			ReplyToCommand(client, "    None found");
			
		// List Mg Models
		ReplyToCommand(client, "Axis Mg Models:");
		if(g_Models_Count_AXISMG> 0)
			for(new model = 0; model < g_Models_Count_AXISMG; ++model)
				ReplyToCommand(client, "    %s", g_Models_AXISMG[model]);
		else
			ReplyToCommand(client, "    None found");
			
		// List Rocket Models
		ReplyToCommand(client, "Axis Rocket Models:");
		if(g_Models_Count_AXISROCKET > 0)
			for(new model = 0; model < g_Models_Count_AXISROCKET; ++model)
				ReplyToCommand(client, "    %s", g_Models_AXISROCKET[model]);
		else
			ReplyToCommand(client, "    None found");			
	}

	return Plugin_Continue;
}

public Action:EventPlayerSpawn(Handle:event,const String:name[],bool:dontBroadcast)
{
	// Set custom skin if plugin enabled
	if (g_Use_Custom_Models && g_PrecacheClean)
		set_random_custom_model(GetClientOfUserId(GetEventInt(event, "userid")));
	return Plugin_Continue;
}

stock set_random_custom_model(client_index)
{
	new team = GetClientTeam(client_index);
	new class = GetEntProp(client_index, Prop_Send, "m_iPlayerClass");
	
	if (team==2)
	{
		if(class == 0)
		{
			SetEntityModel(client_index,g_Models_ALLIEDRIFLE[GetRandomInt(0, g_Models_Count_ALLIEDRIFLE-1)]);
		}
		else if (class == 1)
		{
			SetEntityModel(client_index,g_Models_ALLIEDASSAULT[GetRandomInt(0, g_Models_Count_ALLIEDASSAULT-1)]);
		}
		else if (class == 2) 
		{
			SetEntityModel(client_index,g_Models_ALLIEDSUPPORT[GetRandomInt(0, g_Models_Count_ALLIEDSUPPORT-1)]);
		}
		else if (class == 3)
		{
			SetEntityModel(client_index,g_Models_ALLIEDSNIPER[GetRandomInt(0, g_Models_Count_ALLIEDSNIPER-1)]);
		}
		else if (class == 4)
		{
			SetEntityModel(client_index,g_Models_ALLIEDMG[GetRandomInt(0, g_Models_Count_ALLIEDMG-1)]);
		}
		else if (class == 5)
		{
			SetEntityModel(client_index,g_Models_ALLIEDROCKET[GetRandomInt(0, g_Models_Count_ALLIEDROCKET-1)]);
		}
	}
	
	else if (team==3)
	{
		if(class == 0)
		{
			SetEntityModel(client_index,g_Models_AXISRIFLE[GetRandomInt(0, g_Models_Count_AXISRIFLE-1)]);
		}
		else if (class == 1)
		{
			SetEntityModel(client_index,g_Models_AXISASSAULT[GetRandomInt(0, g_Models_Count_AXISASSAULT-1)]);
		}
		else if (class == 2) 
		{
			SetEntityModel(client_index,g_Models_AXISSUPPORT[GetRandomInt(0, g_Models_Count_AXISSUPPORT-1)]);
		}
		else if (class == 3)
		{
			SetEntityModel(client_index,g_Models_AXISSNIPER[GetRandomInt(0, g_Models_Count_AXISSNIPER-1)]);
		}
		else if (class == 4)
		{
			SetEntityModel(client_index,g_Models_AXISMG[GetRandomInt(0, g_Models_Count_AXISMG-1)]);
		}
		else if (class == 5)
		{
			SetEntityModel(client_index,g_Models_AXISROCKET[GetRandomInt(0, g_Models_Count_AXISROCKET-1)]);
		}
	}	
}

stock set_random_default_model(client_index)
{
	new random = GetRandomInt(0, 1);
	new team = GetClientTeam(client_index);
	new class = GetEntProp(client_index, Prop_Send, "m_iPlayerClass");
	
	if (team==2)
	{
		if(class == 0)
		{
			SetEntityModel(client_index,alliesriflemodels[random]);
		}	
		else if (class == 1)
		{
			SetEntityModel(client_index,alliesassaultmodels[random]);
		}
		else if (class == 2)
		{
			SetEntityModel(client_index,alliessupportmodels[random]);
		}
		else if (class == 3)
		{
			SetEntityModel(client_index,alliessnipermodels[random]);
		}
		else if (class == 4)
		{
			SetEntityModel(client_index,alliesmgmodels[random]);
		}
		else if (class == 5)
		{
			SetEntityModel(client_index,alliesrocketmodels[random]);
		}
	}
	
	if (team==3)
	{
		if(class == 0)
		{
			SetEntityModel(client_index,axisriflemodels[random]);
		}	
		else if (class == 1)
		{
			SetEntityModel(client_index,axisassaultmodels[random]);
		}
		else if (class == 2)
		{
			SetEntityModel(client_index,axissupportmodels[random]);
		}
		else if (class == 3)
		{
			SetEntityModel(client_index,axissnipermodels[random]);
		}
		else if (class == 4)
		{
			SetEntityModel(client_index,axismgmodels[random]);
		}
		else if (class == 5)
		{
			SetEntityModel(client_index,axisrocketmodels[random]);
		}
	}	
}
